import { useState } from 'react';
import registerApp from '../assets/orchestration.jsx'

function Form() {
  const envCnameTarget = import.meta.env.VITE_CNAME_TARGET_DEFAULT || ''
  const [fqdn, setFQDN] = useState('');
  const [cnameTarget, setCnameTarget] = useState(envCnameTarget);
  const [targetHost, setTargetHost] = useState('');
  const [upstreamPort, setUpstreamPort] = useState('');
  const [protocol, setProtocol] = useState('http');


  return (
    <>
      <form className='card' id="create-service" action={
        () => registerApp(fqdn, cnameTarget, targetHost, upstreamPort, protocol)}>

        <h4>DNS</h4>
        <label>
          FQDN
          <input
            type="text"
            name="fqdn"
            value={fqdn}
            onChange={e => setFQDN(e.target.value)}
            placeholder='Target DNS name.'
            required
            autoFocus />
        </label>

        <br />

        <label>
          CNAME Target
          <input
            type="text"
            name="cnameTarget"
            value={cnameTarget}
            onChange={e => setCnameTarget(e.target.value)}
            placeholder='Backend server DNS CNAME'
            required />
        </label>

        <br />

        <h4>Reverse Proxy</h4>

        <label>
          FQDN
          <input
            type="text"
            value={fqdn}
            disabled
            placeholder='Target DNS name' />
        </label>

        <br />

        <label>
          Target Host
          <input
            type="text"
            name="targetHost"
            value={targetHost}
            onChange={e => setTargetHost(e.target.value)}
            placeholder='Network host Domain or IP'
            required />
        </label>

        <br />

        <label>
          Upstream Port
          <input
            type="number"
            name="upstreamPort"
            value={upstreamPort}
            onChange={e => setUpstreamPort(e.target.value)}
            placeholder='Port the target service is listening on.'
            required />
        </label>

        <br />

        <select
          name="protocol"
          value={protocol}
          onChange={e => setProtocol(e.target.value)}>
          <option value="http">http</option>
          <option value="https">https</option>
        </select>

        <br />

        <button
          className="button"
          type="submit">
          Create
        </button>

      </form>
    </>
  )
}

function Home() {
  return (
    <>
      <h2>Deploy New App</h2>
      <Form />
    </>
  )
}

export default Home;